Skip to main content

Create an Angular Front-End Application with a Document Viewer

  • 6 minutes to read

The Web Document Viewer is used in applications that contain client and server parts:

Client
A Web Document Viewer integrated in a client Angular application displays a report provided by the server-side model.
Server
The server is an ASP.NET Core application that handles client data requests and provides access to data sources, report storage, and other back-end capabilities.

This tutorial creates and configures a client Angular application and a server ASP.NET Core backend. The client contains the Web Document Viewer control.

View Example

Prerequisites

Note the following details about package versions:

  • The script version on the client should match the library version on the server.
  • DevExpress npm package versions should be identical.

Server (Back-End) Application

Use the DevExpress CLI Template

You can use DevExpress CLI Templates to create an ASP.NET Core back-end application. Begin with the steps below:

  1. Install DevExpress ASP.NET Core project templates from nuget.org:

    dotnet new install DevExpress.AspNetCore.ProjectTemplates
    
  2. Create a back-end Reporting application for a Document Viewer:

    dotnet new dx.aspnetcore.reporting.backend -n ServerApp --add-designer false
    

    You can use the following parameters to see available command options: -? | -h | --help.

  3. Enable cross-origin requests (CORS). Specify the policy that allows any local application to access the report’s back-end. Use the SetIsOriginAllowed method to set it up.

    Call the UseCors method and pass the policy name as a parameter. The UseCors method should be called after the UseRouting method and before any MVC-related code. Place the UseCors method before the UseMvc or UseEndpoints methods.

    Open the application startup file and insert the following code:

    var builder = WebApplication.CreateBuilder(args);
    
    builder.Services.AddCors(options => {
        options.AddPolicy("AllowCorsPolicy", builder => {
            // Allow all ports on local host.
            builder.SetIsOriginAllowed(origin => new Uri(origin).Host == "localhost");
            builder.AllowAnyHeader();
            builder.AllowAnyMethod();
        });
    });
    
    var app = builder.Build();
    
    app.UseRouting();
    app.UseCors("AllowCorsPolicy");
    
    app.UseEndpoints(endpoints => {
        endpoints.MapControllerRoute(
            name: "default",
            pattern: "{controller=Home}/{action=Index}/{id?}");
    });
    
    app.Run();
    
  4. To run the server-side application, run the following command:

    cd ServerApp
    dotnet run
    

Use Visual Studio Template

To create a back-end application from a Microsoft or DevExpress Template in Visual Studio, review the following help topics:

Client (Front-End) Application

Follow the steps below to create and configure the client part:

  1. Make sure you have the current Node.js version with npm installed on your machine.

    node -v
    npm -v
    
  2. Open the console window and install the Angular CLI v17+ globally.

    npm install -g @angular/cli
    

    When prompted for options, select default settings (press Enter).

  3. Run the command to create a new Angular project:

    ng new angular-document-viewer
    

    Refer to the Angular documentation for information on the Angular application structure.

  4. Install the following packages:

    cd angular-document-viewer
    npm install devextreme@25.1-stable devextreme-angular@25.1-stable @devexpress/analytics-core@25.1-stable devexpress-reporting-angular@25.1-stable
    

    Note

    Front-end and back-end applications should use the same version of DevExpress controls.

  5. Replace the content of the src\app\app.component.ts file with the following code:

    import { Component, ViewEncapsulation } from '@angular/core';
    import { CommonModule } from '@angular/common';
    import { RouterOutlet } from '@angular/router';
    import { DxReportViewerModule } from 'devexpress-reporting-angular';
    
    
    @Component({
      selector: 'app-root',
      encapsulation: ViewEncapsulation.None,
      standalone: true,
      imports: [
      CommonModule, 
      RouterOutlet,
      DxReportViewerModule
      ],
      templateUrl: './app.component.html',
      styleUrls: [
        "../../node_modules/devextreme/dist/css/dx.light.css",
        "../../node_modules/@devexpress/analytics-core/dist/css/dx-analytics.common.css",
        "../../node_modules/@devexpress/analytics-core/dist/css/dx-analytics.light.css",
        "../../node_modules/devexpress-reporting/dist/css/dx-webdocumentviewer.css"
      ]
    })
    export class AppComponent {
        title = 'DXReportViewerSample';
        reportUrl: string = 'TestReport';
        hostUrl: string = 'http://localhost:5000/';
        // Use this line if you use an ASP.NET MVC backend
        //invokeAction: string = "/WebDocumentViewer/Invoke";
        // Use this line if you use an ASP.NET Core backend
        invokeAction: string = '/DXXRDV';
    
    }
    

    For more information on component options, review the following help topic: Document Viewer Client-Side Configuration in an Angular Application.

  6. Replace the content of the src\app\app.component.html file with the following code to add dx-report-viewer Angular component:

    <dx-report-viewer [reportUrl]="reportUrl" height="800px">
    <dxrv-request-options [invokeAction]="invokeAction" [host]="hostUrl"></dxrv-request-options>
    </dx-report-viewer>
    

Run the Project

  1. Run the server application.

    Make sure to specify the correct server-side port (5000 in this example) and report name (TestReport in this example) in the src\app\app.component.ts file.

  2. Run the client application:

    npm start
    

    Note

    For recent Angular versions (16 and later) you may have to compile the Angular project with the skipLibCheck option set to true, and increase the initial budget setting in the angular.json file up to 5mb to avoid compilation errors.

  3. Open the http://localhost:4200/ location in the browser to see the result.

    Web Document Viewer Page

Troubleshooting

When you start the application, you may encounter the following problems:

Page Is Blank

The Document Viewer page is blank. The following error message is displayed at the bottom of the page:

Could not open report ‘TestReport’

Check the following:

  • The backend application is up and running.
  • The backend application runs on the port specified in the host setting of the Document Viewer component.
  • The application’s URI is compliant with the CORS policy specified in your back-end application.
  • The reportUrl setting value matches an existing report. For the backend application, ensure that either the Reports folder contains a reportUrl.repx file or the ReportsFactory.Reports dictionary contains the reportUrl entry (if the back-end application originated from the DevExpress template).
  • The version of DevExpress npm packages should match the version of NuGet packages. Enable Development Mode to check for a library version mismatch on every request to the server. For details, review the following help topic: Server-Side Libraries Version.

Refer to the following topic for more information: Troubleshooting.

For information on how to identify the cause of an issue, refer to the following topic: Reporting Application Diagnostics.

What’s Next

Now that you’ve created a basic Angular app with a Document Viewer, you can continue to extend your application with the following features:

Client-Side Configuration
Integrate the Document Viewer for Web into your Angular-based application.
Specify Parameter Values
Set parameter values in the Document Viewer
Customize Toolbar and Tab Panel
Customize available Document Viewer elements.
See Also

Create a Vue Front-End Application with a Document Viewer
- 4 minutes to read
The Web Document Viewer is used in applications that contain client and server parts:
- Client
- A Web Document Viewer integrated in a client Vue application displays a report provided by the server-side model.
- Server
- The server is an ASP.NET Core application that handles client data requests and provides access to data sources, report storage, and other back-end capabilities.
This tutorial creates and configures a client React application and a server ASP.NET Core backend. The client contains the Web Document Viewer control.
Prerequisites
- Node.js v18.3 or later
- .NET 8 SDK or later
Note the following details about package versions:
- The script version on the client should match the library version on the server.
- DevExpress npm package versions should be identical.
Server (Back-End) Application
Use the DevExpress CLI Template
You can use DevExpress CLI Templates to create an ASP.NET Core back-end application. Begin with the steps below:
Install DevExpress ASP.NET Core project templates from nuget.org:
dotnet new install DevExpress.AspNetCore.ProjectTemplatesCreate a back-end Reporting application for a Document Viewer:
dotnet new dx.aspnetcore.reporting.backend -n ServerApp --add-designer falseYou can use the following parameters to see available command options:
-? | -h | --help.Enable cross-origin requests (CORS). Specify the policy that allows any local application to access the report’s back-end. Use the SetIsOriginAllowed method to set it up.
Call the UseCors method and pass the policy name as a parameter. The
UseCorsmethod should be called after theUseRoutingmethod and before any MVC-related code. Place theUseCorsmethod before theUseMvcorUseEndpointsmethods.Open the application startup file and insert the following code:
var builder = WebApplication.CreateBuilder(args); builder.Services.AddCors(options => { options.AddPolicy("AllowCorsPolicy", builder => { // Allow all ports on local host. builder.SetIsOriginAllowed(origin => new Uri(origin).Host == "localhost"); builder.AllowAnyHeader(); builder.AllowAnyMethod(); }); }); var app = builder.Build(); app.UseRouting(); app.UseCors("AllowCorsPolicy"); app.UseEndpoints(endpoints => { endpoints.MapControllerRoute( name: "default", pattern: "{controller=Home}/{action=Index}/{id?}"); }); app.Run();To run the server-side application, run the following command:
cd ServerApp dotnet run
Use Visual Studio Template
To create a back-end application from a Microsoft or DevExpress Template in Visual Studio, review the following help topics:
- Document Viewer Server-Side Application (ASP.NET Core)
- Document Viewer’s Server-Side Configuration (ASP.NET MVC)
Client (Front-End) Application
Create a Vue application with the default preset:
npm create vue@latest vue-document-viewerNavigate to the project folder and install DevExpress npm packages:
cd vue-document-viewer npm install devextreme@25.1-stable @devexpress/analytics-core@25.1-stable devexpress-reporting@25.1-stableCreate a src/App.vue file with the following content:
<template> <div ref="viewer" style="position: absolute; left: 0; right: 0; top: 0; bottom: 0"></div> </template> <script> import 'devexpress-reporting/dx-webdocumentviewer'; import {DxReportViewer} from 'devexpress-reporting/dx-webdocumentviewer'; import * as ko from 'knockout'; export default { name: "WebDocumentViewer", mounted() { const reportUrl = ko.observable("TestReport"); const viewerRef = this.$refs.viewer; const requestOptions = { host: " http://localhost:5000/", invokeAction: "DXXRDV" }; const viewer = new DxReportViewer(viewerRef, { reportUrl, requestOptions }); viewer.render(); }, beforeUnmount() { ko.cleanNode(this.$refs.viewer); } }; </script>Add styles to the src/main.js file:
import "devextreme/dist/css/dx.light.css"; import "@devexpress/analytics-core/dist/css/dx-analytics.common.css"; import "@devexpress/analytics-core/dist/css/dx-analytics.light.css"; import "devexpress-reporting/dist/css/dx-webdocumentviewer.css"; import { createApp } from 'vue' import App from './App.vue' createApp(App).mount('#app')Remove default project styles to avoid conflicts. To do this, remove the ./assets/main.css import in the main.js file.
Run the Project
Run the server application.
Make sure to specify the correct server-side port (5000 in this example) and report name (TestReport in this example) in the Viewer.vue file.
Run the client application:
npm run devOpen your browser and navigate to the URL specified in the command output to see the result.
Troubleshooting
When you start the application, you may encounter the following issues:
Page Is Blank
The Document Viewer page is blank. The following error message is displayed at the bottom of the page:
Could not open report ‘TestReport’
Check the following:
- The backend application is up and running.
- The backend application runs on the port specified in the
hostsetting of the Document Viewer component. - The application’s URI is compliant with the CORS policy specified in your back-end application.
- The
reportUrlsetting value matches an existing report. For the backend application, ensure that either the Reports folder contains a reportUrl.repx file or the ReportsFactory.Reports dictionary contains the reportUrl entry (if the back-end application originated from the DevExpress template). - The version of DevExpress npm packages should match the version of NuGet packages. Enable Development Mode to check for a library version mismatch on every request to the server. For details, review the following help topic: Server-Side Libraries Version.
Refer to the following topic for more information: Troubleshooting.

Skip to main content
All docs
V25.2
  • Document Viewer Client-Side Configuration in React Applications

    • 4 minutes to read

    Use the ReportViewer component to integrate the Web Document Viewer into your React-based application.

    Root Options

    The following table lists ReportViewer component options:

    Option

    Required / Optional

    Description

    reportUrl

    Required

    A string identifier used by server-side report name resolution services to instantiate a report. For more information, review the following help topic: Open a Report in ASP.NET Core Application.

    width

    Optional

    A string that defines Document Viewer width. The default value is ‘100%’.

    height

    Optional

    A string that defines Document Viewer height. The default value is ‘700px’.

    developmentMode

    Optional

    A Boolean value that enables Development mode for extended diagnostics. Review the following help topic for more information: Trooubleshooting: Server-Side Libraries Version.

    cssClass

    Optional

    A string that specifies the CSS class name to attach to the root div element.

    isMobile

    Optional

    A Boolean value that specifies whether to configure the Document Viewer for mobile devices. Refer to the following topic for more information: Mobile Mode.

    rtl

    Optional

    A Boolean value that specifies if a right-to-left layout is enabled in the Document Viewer’s UI.

    Nested Options

    RequestOptions

    A nested component that allows you to specify where to send requests from the Document Viewer.

    Option

    Required / Optional

    Description

    host

    Required

    A server-side project’s URI.

    invokeAction

    Required

    The URI path of the controller action that processes requests.

    getLocalizationAction

    Optional

    The URI path of the controller action used to customize localization strings.

    RemoteSettings

    A nested component that configures the Web Document Viewer to display documents that are created remotely with the DevExpress Report and Dashboard Server.

    Option

    Required / Optional

    Description

    serverUri

    Required

    Specifies the Report and Dashboard Server URI.

    authToken

    Required

    Specifies the Bearer token to access documents on the DevExpress Report and Dashboard Server.

    MobileModeSettings

    A nested component that provides options for the Web Document Viewer’s mobile mode (if the root isMobile option is enabled).

    Option

    Required / Optional

    Description

    readerMode

    Optional

    Specifies whether to enable a reader mode that displays document pages without page borders.

    animationEnabled

    Optional

    Specifies whether actions are animated.

    TabPanelSettings

    A nested component that allows you to customize the Document Viewer’s tab panel.

    Option

    Required / Optional

    Description

    position

    Optional

    Specifies the tab panel’s position (“Left” or “Right”).

    width

    Optional

    Specifies the tab panel’s width.

    ExportSettings

    A nested component that applies Web Document Viewer print and export settings.

    Option

    Required / Optional

    Description

    useSameTab

    Optional

    Specifies if the print and export operations are performed in the same browser tab as the Document Viewer control.

    showPrintNotificationDialog

    Optional

    Specifies whether to display an additional dialog that allows users to download the PDF file sent to printing.

    useAsynchronousExport

    Optional

    Allows you to export documents asynchronously.

    SearchSettings

    A nested component that allows you to specify Document Viewer search settings.

    Option

    Required / Optional

    Description

    searchEnabled

    Optional

    Allows you to hide search actions.

    useAsyncSearch

    Optional

    Specifies whether the Document Viewer uses asynchronous search.

    Callbacks

    A nested component that provides callbacks to customize the Document Viewer. These callbacks correspond to client-side events at the Document Viewer control level.

    For a list of available events and details on how to use each event, refer to the following help topic: Document Viewer Client-Side API.

    Usage

    The following code configures the ReportViewer component in a React application. The code does the following:

    • Uses the CustomizeMenuActions event to hide the Print and Print Page commands from the toolbar.
    • Sets the tab panel’s width to 500px and moves it to the left side.
    • Disables asynchronous export and opens another browser tab for print and export operations.
    • Hides search actions from the Toolbar and Tab Panel.
    'use client';
    import ReportViewer, { RequestOptions, Callbacks, TabPanelSettings, ExportSettings, SearchSettings} from 'devexpress-reporting-react/dx-report-viewer';
    import { ActionId } from 'devexpress-reporting/dx-webdocumentviewer'
    
    
    
    function App() {
      const onCustomizeMenuActions = ({ args }: { args: any }): void => {
        // Hide the "Print" and "PrintPage" actions. 
        var printAction = args.GetById(ActionId.Print);
        if (printAction)
            printAction.visible = false;
        var printPageAction = args.GetById(ActionId.PrintPage);
        if (printPageAction)
            printPageAction.visible = false;
        }
      return (
        <ReportViewer reportUrl="TestReport">
          <RequestOptions host="http://localhost:5000/" invokeAction="DXXRDV" />
          <TabPanelSettings width={500} position='Left'/>
          <ExportSettings useSameTab={false} useAsynchronousExport={false}/>
          <SearchSettings searchEnabled={false}/>
          <Callbacks CustomizeMenuActions={onCustomizeMenuActions} />
        </ReportViewer>        
      )
    }
    
    export default App
    

    The image below shows the resulting Web Document Viewer:

    Report Viewer Configuration